#include <avr/io.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>

unsigned long t = 0;

//function called when it' interrupted
ISR(TIM1_COMPA_vect){
  OCR0A = 
    //choose one of them to generate music
    //(t|t>>17)>>(t>>7)|(t<<2|t<<8)>>(t>>11)|(t<<2|t<<11)>>(t>>17);
    //((t>>8|t-2)&(2-t|8<<t))<<((t>>8|t-2)&(2-t|8<<t))>>((t>>8|t-2)&(2-t|8<<t));
    //((t&4096)?((t*(t^t%255)|(t>>4))>>1):(t>>3)|((t&8192)?t<<2:t));
    //t*((t>>12|t>>8)&63&t>>4);   // by viznut
    //((-t&4095)*(255&t*(t&t>>13))>>12)+(127&t*(234&t>>8&t>>3)>>(3&t>>14)); // by tejeez
    // t*(t>>11&t>>8&123&t>>3);    // by tejeez
    // t*((t>>9|t>>13)&25&t>>6);   // by visy
    // (t*(t>>5|t>>8))>>(t>>16);  // by tejeez
    // ((t*(t>>8|t>>9)&46&t>>8))^(t&t>>13|t>>6); // by xpansive
    //((t&4096)?((t*(t^t%255)|(t>>4))>>1):(t>>3)|((t&8192)?t<<2:t)); // by skurk (raer's version)
    //(t>>7|t|t>>6)*10+4*(t&t>>13|t>>6); // by viznut, xpansive, varjohukka
    //t*5&(t>>7)|t*3&(t*4>>10); // by miiro
    (t|(t>>9|t>>7))*t&(t>>11|t>>9); // by red
    // v=(v>>1)+(v>>4)+t*(((t>>16)|(t>>6))&(69&(t>>9))); // by pyryp
    // (t>>6|t|t>>(t>>16))*10+((t>>11)&7);  //by viznut
    // (t*(4|7&t>>13)>>((~t>>11)&1)&128) + ((t)*(t>>11&t>>13)*((~t>>9)&3)&127); // by stimmer

  t++;
  TCNT1=0x000;
}

int main(void) {
  //set up PMW by TIMER0
  TCCR0A |= (1 << COM0A1) | (1 << COM0A0) | (0 << WGM02) | (1 << WGM01) | (1 << WGM00); //fast PWM to OC0A (PB2)
  TCCR0B |= (0 << CS02) | (0 << CS01) | (1 << CS00); // set /1 prescaler of TIMER0
  DDRB |= (1 << PB2); // set PB2 as output

  //set up timer by TIMER1
  OCR1A = 2500; // update tune every (1 / 20Mhz) X 2500 = 125u sec
  TCCR1B |= (0 << CS12) | (0 << CS11) | (1 << CS10); // set /1 prescaler of TIMER1
  TCNT1 = 0x000; //initialize counter
  sei(); //enable grobal interruption

  TIMSK1 |= (1 << OCIE1A); // set interruption by comparing with A resistor

  while(1){
    //wainting interruption
  }

}
